<template>
  <ContentSection
    :id="`c${data.id}`"
    :border="border"
    :outer-spacing-horizontal="outerSpacingHorizontal"
    :space-after="spaceAfter"
    :space-before="spaceBefore"
  >
    <CeHeader
      v-if="isCeHeaderVisible === true"
      slot="header"
      :header="data.content.header"
      :layout="ceHeaderLayout"
      :subheader="data.content.subheader"
    />

    <Component
      :is="`ce-${data.type}`"
      v-if="data.type !== 'header'"
      v-bind="{
        ...data.content,
        ...data.appearance
      }"
    />
  </ContentSection>
</template>

<script>
import ContentSection from './ContentSection'

import CeGrid from './Ce/CeGrid'
import CeHeader from './Ce/CeHeader'
import CeHtml from './Ce/CeHtml'

const SPACINGS = {
  none: 'none',
  'extra-small': 'xs',
  small: 'sm',
  medium: 'md',
  large: 'lg',
  'extra-large': 'xl'
}

export default {
  name: 'ContentElementCms',

  components: {
    ContentSection,

    CeHeader,
    'ce-structured_content': CeGrid,
    'ce-text': CeHtml
  },

  props: {
    data: {
      type: Object,
      required: true
    },

    outerSpacingHorizontal: {
      type: String,
      default: undefined
    }
  },

  computed: {
    border () {
      return this.data.appearance.frame === 'border' ? 'solid' : undefined
    },

    ceHeaderLayout () {
      const parsedLayoutId = parseInt(this.data.content.headerLayout)

      return (parsedLayoutId >= 1 && parsedLayoutId <= 5) ? parsedLayoutId : 2
    },

    isCeHeaderVisible () {
      return (
        !!this.data.content.header === true &&
        parseInt(this.data.content.headerLayout) !== 100
      )
    },

    spaceAfter () {
      return SPACINGS[this.data.appearance.spaceAfter]
    },

    spaceBefore () {
      return SPACINGS[this.data.appearance.spaceBefore]
    }
  }
}
</script>
